%define pam_redhat_version 0.99.9-1


Distribution:	CCux
Packager:  	Christian Metzen <metzench@ccux-linux.de>

Summary:   	A security tool which provides authentication for applications.
Name:      	pam
Version:   	1.0.1
Release:   	1
Epoch:		1
Provides:	pam
License: 	GNU/GPL
URL:		http://www.us.kernel.org/pub/linux/libs/pam/index.html
Group:     	System/Base
Source0: 	Linux-PAM-%{version}.tar.bz2
Source1: 	dlopen.sh
Source2:	other.pamd
Source3: 	pam-redhat-%{pam_redhat_version}.tar.bz2
Source4:	system-auth.pamd
Source5:	50-default.perms
Patch0: 	pam-0.99.7.0-redhat-modules.patch
BuildRoot: 	%{_tmppath}/%{name}-buildroot
Requires:	cracklib cracklib-dicts >= 2.8 base-config >= 1.3.4-1 gnutls >= 1.3.1-4
Prereq: 	grep, mktemp, sed, coreutils, /sbin/ldconfig
BuildPrereq: 	autoconf bison flex sed cracklib db-devel
BuildPrereq: 	perl pkg-config cracklib-dicts
BuildRequires:	gnutls-devel >= 1.3.1-4
BuildRequires:  glibc-devel

%description
PAM (Pluggable Authentication Modules) is a system security tool that
allows system administrators to set authentication policy without
having to recompile programs that handle authentication.

%package devel
Summary: 	pam development headers.
Group:     	%{group}
Requires: 	%{name} = %{version}-%{release}

%description devel
PAM (Pluggable Authentication Modules) is a system security tool that
allows system administrators to set authentication policy without
having to recompile programs that handle authentication. This package
contains header files and static libraries used for building both
PAM-aware applications and modules for use with PAM.

%post
ldconfig

%postun
ldconfig

%prep
%setup -n Linux-PAM-%{version} -a 3
mv pam-redhat-%{pam_redhat_version}/* modules

%patch0 -p1
mkdir -p doc/txts
for readme in modules/pam_*/README ; do
	cp -f ${readme} doc/txts/README.`dirname ${readme} | sed -e 's|^modules/||'`
done

libtoolize -f -c
aclocal-1.10 -I m4
autoconf
automake-1.10


%build
rm -Rf $RPM_BUILD_ROOT
./configure 	--with-mailspool=/var/mail \
		--enable-read-both-confs \
		--sysconfdir=%_sysconfdir \
		--mandir=%_mandir
make

%install
make install DESTDIR=$RPM_BUILD_ROOT LDCONFIG=:


# Install default configuration files.
install -m 755 -d $RPM_BUILD_ROOT%_sysconfdir/pam.d
install -m 644 %{SOURCE2} $RPM_BUILD_ROOT%_sysconfdir/pam.d/other
install -m 644 %{SOURCE4} $RPM_BUILD_ROOT%_sysconfdir/pam.d/system-auth
install -m 600 /dev/null $RPM_BUILD_ROOT%_sysconfdir/security/opasswd
install -m 644 %{SOURCE5} $RPM_BUILD_ROOT%_sysconfdir/security/console.perms.d/50-default.perms

# Forcibly strip binaries.
strip $RPM_BUILD_ROOT%_sbindir/* ||:


# Remove docs for modules we exclude from the files manifest.
#rm doc/*/*pam_pwdb*

# Install man pages.
install -d -m 755 $RPM_BUILD_ROOT%{_mandir}/man{3,5,8}
install -m 644 doc/man/*.3 $RPM_BUILD_ROOT%{_mandir}/man3/
install -m 644 doc/man/*.8 $RPM_BUILD_ROOT%{_mandir}/man8/

# Remove pam_pwdb so it won't error out
#rm -rf modules/pam_pwdb

# Check for module problems.  Specifically, check that every module we just
# installed can actually be loaded by a minimal PAM-aware application.
/sbin/ldconfig -n $RPM_BUILD_ROOT/%{_lib}
for module in $RPM_BUILD_ROOT/%{_lib}/security/pam*.so ; do
	if ! env LD_LIBRARY_PATH=$RPM_BUILD_ROOT/%{_lib} \
		 $RPM_SOURCE_DIR/dlopen.sh -ldl -lpam -L$RPM_BUILD_ROOT/%{_lib} ${module} ; then
		echo ERROR module: ${module} cannot be loaded.
		exit 1
	fi
done

for phase in auth acct passwd session ; do
	ln -sf pam_unix.so $RPM_BUILD_ROOT/%{_lib}/security/pam_unix_${phase}.so 
done

# Remove .la files and make new .so links -- this depends on the value
# of _libdir not changing, and *not* being /usr/lib.
install -d -m 755 $RPM_BUILD_ROOT%{_libdir}
for lib in libpam libpamc libpam_misc ; do
    ln -sf ../../%{_lib}/${lib}.so.0 $RPM_BUILD_ROOT%{_libdir}/${lib}.so
    rm -f $RPM_BUILD_ROOT/%{_lib}/${lib}.so
    rm -f $RPM_BUILD_ROOT/%{_lib}/${lib}.la
done
rm -f $RPM_BUILD_ROOT/%{_lib}/security/*.la

# Duplicate doc file sets.
rm -fr $RPM_BUILD_ROOT/usr/share/doc/pam

%find_lang Linux-PAM

%files -f Linux-PAM.lang
%defattr(-,root,root)
%doc Copyright
%doc doc/specs/rfc86.0.txt

%dir /etc/pam.d
%config(noreplace) /etc/pam.d/other
%config(noreplace) /etc/pam.d/system-auth
%exclude /etc/environment
/%_lib/libpam.so.*
/%_lib/libpamc.so.*
/%_lib/libpam_misc.so.*
/sbin/pam_console_apply
/sbin/pam_tally
/sbin/pam_tally2
/sbin/unix_update
%attr(4755,root,root) /sbin/pam_timestamp_check
%attr(4755,root,root) /sbin/unix_chkpwd
%dir /%_lib/security
/%{_lib}/security/pam_access.so
/%{_lib}/security/pam_chroot.so
/%{_lib}/security/pam_console.so
/%{_lib}/security/pam_cracklib.so
/%{_lib}/security/pam_debug.so
/%{_lib}/security/pam_deny.so
/%{_lib}/security/pam_env.so
/%{_lib}/security/pam_filter.so
/%{_lib}/security/pam_ftp.so
/%{_lib}/security/pam_group.so
/%{_lib}/security/pam_issue.so
/%{_lib}/security/pam_lastlog.so
/%{_lib}/security/pam_limits.so
/%{_lib}/security/pam_listfile.so
/%{_lib}/security/pam_localuser.so
/%{_lib}/security/pam_loginuid.so
/%{_lib}/security/pam_mail.so
/%{_lib}/security/pam_mkhomedir.so
/%{_lib}/security/pam_motd.so
/%{_lib}/security/pam_nologin.so
/%{_lib}/security/pam_permit.so
/%{_lib}/security/pam_postgresok.so
#/%{_lib}/security/pam_pwdb.so
#/%{_lib}/security/pam_rhosts_auth.so
/%{_lib}/security/pam_rootok.so
#/%{_lib}/security/pam_rps.so
/%{_lib}/security/pam_securetty.so
/%{_lib}/security/pam_shells.so
#/%{_lib}/security/pam_stack.so
/%{_lib}/security/pam_stress.so
/%{_lib}/security/pam_succeed_if.so
/%{_lib}/security/pam_tally.so
/%{_lib}/security/pam_time.so
/%{_lib}/security/pam_timestamp.so
/%{_lib}/security/pam_unix.so
/%{_lib}/security/pam_unix_acct.so
/%{_lib}/security/pam_unix_auth.so
/%{_lib}/security/pam_unix_passwd.so
/%{_lib}/security/pam_unix_session.so
/%{_lib}/security/pam_userdb.so
/%{_lib}/security/pam_warn.so
/%{_lib}/security/pam_wheel.so
/%{_lib}/security/pam_xauth.so
/%{_lib}/security/pam_filter
/%{_lib}/security/pam_echo.so
/%{_lib}/security/pam_umask.so
/%{_lib}/security/pam_exec.so
/%{_lib}/security/pam_keyinit.so
/%{_lib}/security/pam_rhosts.so
/%{_lib}/security/pam_faildelay.so
/%{_lib}/security/pam_namespace.so
/%{_lib}/security/pam_tally2.so

%dir %_sysconfdir/security
%config(noreplace) %_sysconfdir/security/access.conf
%config(noreplace) %_sysconfdir/security/chroot.conf
%config %_sysconfdir/security/console.perms
%config(noreplace) %_sysconfdir/security/console.handlers
%config(noreplace) %_sysconfdir/security/group.conf
%config(noreplace) %_sysconfdir/security/limits.conf
%config(noreplace) %_sysconfdir/security/pam_env.conf
%config(noreplace) %_sysconfdir/security/time.conf
%config(noreplace) %_sysconfdir/security/opasswd
%config(noreplace) %_sysconfdir/security/namespace.conf
%config(noreplace) %_sysconfdir/security/namespace.init
%dir %_sysconfdir/security/console.apps
%dir %_sysconfdir/security/console.perms.d
%config %_sysconfdir/security/console.perms.d/50-default.perms
%dir /var/run/console
%_mandir/man5
%_mandir/man8

%files devel
%defattr(-,root,root)
%_includedir/security/
%_mandir/man3
#%_libdir/libpam.a
%_libdir/libpam.so
#%_libdir/libpamc.a
%_libdir/libpamc.so
#%_libdir/libpam_misc.a
%_libdir/libpam_misc.so
%_datadir/doc/Linux-PAM/draft-morgan-pam-current.txt
%_datadir/doc/Linux-PAM/index.html
%_datadir/doc/Linux-PAM/rfc86.0.txt

%clean
rm -rf $RPM_BUILD_ROOT

%changelog
* Mon May 12 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.1-1
- Version update
* Thu Jan 18 2007 Karsten Brockmann <arcam@ccux-linux.de> 0.99.7.0-1
- Version update
* Sun Oct 08 2006 Karsten Brockmann <arcam@ccux-linux.de> 0.99.6.3-2
- edited pam_console rules to not interfere with udev
* Tue Oct 03 2006 Karsten Brockmann <arcam@ccux-linux.de> 0.99.6.3-1
- Version update
* Sun Feb 12 2006 Karsten Brockmann <arcam@ccux-linux.de> 0.99.3.0-2
- removed unneccessary symlink to gnutls, cleaned up specfile
- removed rogue libprelude dependency (fixes nasty login bug)
* Wed Jan 18 2006 Karsten Brockmann <arcam@ccux-linux.de> 0.99.3.0-1
- Version Update
* Mon Jan 02 2006 Christian Metzen <metzench@ccux-linux.de> 0.99.2.1-4
- Minor fix in script
* Mon Jan 02 2006 Christian Metzen <metzench@ccux-linux.de> 0.99.2.1-3
- Added sanity check
* Sun Jan 01 2006 Christian Metzen <metzench@ccux-linux.de> 0.99.2.1-2
- Added newest base-config as requirement
* Fri Dec 16 2005 Christian Metzen <metzench@ccux-linux.de> 0.99.2.1-1
- Version update
* Thu Dec 15 2005 Christian Metzen <metzench@ccux-linux.de> 0.81-4
- Added missing .so.0 symlinks
* Thu Dec 15 2005 Christian Metzen <metzench@ccux-linux.de> 0.81-3
- Version downgrade for now, readded pam-modules, corrected symlink bug in old 0.81 package
* Mon Dec 05 2005 Karsten Brockmann <arcam@ccux-linux.de> 0.99.2.0-1
- Version Update, temporarily removed additional RedHat pam-modules
* Sun Nov 06 2005 Christian Wasem <wasem@ccux-linux.de> 0.81-2
- moved sed replacements in libdir patch
* Sat Nov 05 2005 Karsten Brockmann <arcam@ccux-linux.de> 0.81-1
- Version Update
* Sat Aug 27 2005 Christian Metzen <metzench@ccux-linux.de> 0.80-6
- Modified system-auth
* Sat Aug 27 2005 Christian Metzen <metzench@ccux-linux.de> 0.80-5
- Added Modules again, added system-auth
* Sun Aug 14 2005 Christian Metzen <metzench@ccux-linux.de> 0.80-4
- Modified other more strictly,some more sec modules
* Sun Aug 14 2005 Christian Metzen <metzench@ccux-linux.de> 0.80-3
- Added PATH Config
* Sun Aug 14 2005 Christian Metzen <metzench@ccux-linux.de> 0.80-2
- Cleaned out specfile
* Sun Aug 14 2005 Christian Metzen <metzench@ccux-linux.de> 0.80-1
- Initial Release
